# PageCDN - Easy Speedup

PageCDN's Easy Speedup Plugin will speed up your wordpress website by up to 10x and is 10x easier to set up. You will need little technical know-how to get maximum website speed with this incredibly sophisticated yet easy to install plugin.


## Free CDN

Our [free CDN](https://pagecdn.com/public-cdn) accelerates open source libraries, thousands of WordPress themes and plugins, fonts and more. It takes each resource separately and intelligently optimizes it using the best information available.

The benefit of our free CDN is that many websites re-use the same free files on our CDN. This allows browsers to share cache of one website with the other. So, the free CDN not only comes with free bandwidth, it enables cache re-use at internet scale - that ultimately makes your site faster than ever.


## Premium CDN

Premium CDN enables aggressive cloud based optimizations for your website through [PageCDN](https://pagecdn.com). PageCDN uses many advanced and never-seen-before techniques to optimize Content, Delivery and Caching of your website files for best performance.


## Premium Features

* 10X easier setup for the same feature-set
* Full HTTPS and HTTP/2
* Brotli-11 compression
* HTTP/2 Server Push (configurable through PageCDN dashboard)
* Immutable Caching
* Accelerates delivery through PageCDN Global Edge Network
* Remove Query String from static resources to make them more cacheable
* Cache reuse across sites with free open source CDN
* Leverage browser caching for fonts
* Cloud based image optimization and WebP conversion
* Cloud based CSS and JavaScript minification
* Set directories to be optimized through plugin
* Set directories and file extensions to be ignored
* Automatically optimize DNS lookups and HTTP caching by loading [better optimized fonts](https://pagecdn.com/lib/easyfonts)
* Automatically optimize DNS lookups and delivery by changing resources that load from different Public CDNs to load from single [Public CDN](https://pagecdn.com/public-cdn) instead
* Automatically optimize HTTP caching and delivery by searching and linking open source library files from [Open source Libraries CDN](https://pagecdn.com/public-cdn/libs)
* Automatically optimize HTTP caching and delivery by searching and linking theme and plugin files from [Open source WordPress CDN](https://pagecdn.com/public-cdn/wp-themes)


## Which resources are available on PageCDN's Free CDN?

[PageCDN](https://pagecdn.com/)'s Free Open Source CDN hosts the following type of content for free.
* Open source libraries.
* Open source WordPress themes.
* Open source HTML5 themes.
* [Easy Fonts](https://pagecdn.com/lib/easyfonts) - A replacement of Google fonts with better caching and easy to use CSS font classes.
* [Patterns](https://pagecdn.com/lib/subtlepatterns) from Subtlepatterns.
* Open source WordPress plugins.


## Available Open source Libraries

There are currently [100s of libraries](https://pagecdn.com/public-cdn/libs) available on Public CDN. Some noteable libraries are listed on below listed CDN pages:

* [jQuery CDN](https://pagecdn.com/lib/jquery)
* [Bootstrap CDN](https://pagecdn.com/lib/bootstrap)
* [Font Awesome CDN](https://pagecdn.com/lib/font-awesome)
* [AngularJS CDN](https://pagecdn.com/lib/angularjs)
* [Zepto CDN](https://pagecdn.com/lib/zepto)
* [Easy Fonts CDN](https://pagecdn.com/lib/easyfonts)
* [Waypoints CDN](https://pagecdn.com/lib/waypoints)
* [Lazysizes CDN](https://pagecdn.com/lib/lazysizes)
* [Framework7 CDN](https://pagecdn.com/lib/framework7)
* [Semantic ui CDN](https://pagecdn.com/lib/semantic-ui)
* [Selectize js CDN](https://pagecdn.com/lib/selectize)
* [Slim scroll CDN](https://pagecdn.com/lib/jquery-slimscroll)
* [Backbone CDN](https://pagecdn.com/lib/backbone)
* [Leaflet CDN](https://pagecdn.com/lib/leaflet)


## Installation

Detailed setup guide is available [here](https://pagecdn.com/docs/quick-start#wordpress-integration). For quick installation, please follow these steps:
1. Install the plugin from WordPress, and activate it.
2. Activation will instantly enable all Free features.
3. Open PageCDN Plugin page from Settings menu.
4. Get API Key from [PageCDN Settings](https://pagecdn.com/account/settings/integration) and paste to relevant box in Premium CDN section on Plugin settings page.
5. Hit 'Save Changes'.
6. Done :)


